#!usr/bin/perl -w

use strict;
use warnings;
use Getopt::Long;

my ($groupfile, $output);

my $usage = "

Usage: $0

OPTIONS:
--groups [FILE] ----> summary of linkage groups from ONEMAP output

";

Getopt::Long::GetOptions(
'groups=s' => \$groupfile,
) or die "$usage\n\n";

if (!defined $groupfile) {die "designate file containing onemap group summary (--groups)\n";}

### create marker -> group summary based on ONEMAP output
my $group_n = 0;
my $group_id;
my @group_list;

open (my $out_markLG, '>', 'ld_comp.marker_lgs.txt') or die "could not open input file\n";
open (my $read_groups, '<', $groupfile) or die "could not open input file\n";
while (my $line = <$read_groups>) {
	chomp $line;
	$line =~ s/^\s+|\s+$//g;
	if ($line =~ /^Group/) {
		$group_n++;
		if ($group_n < 10) {$group_id = 'group_00'."$group_n";}
		elsif ($group_n < 100) {$group_id = 'group_0'."$group_n";}
		elsif ($group_n < 1000) {$group_id = 'group_'."$group_n";}
		else {die "too many groups braggh\n";}
		push @group_list, $group_id;
	}
	elsif ($line =~ /^Unlinked/) {last;}
	else {
		if ($line =~ /\S+/) {
			if (!defined $group_id) {next;}
			my @markers = split /\s+/, $line;
			foreach my $print_marker (@markers) {print $out_markLG "$print_marker\t$group_id\n";}
		}
	}
}
close $read_groups;
close $out_markLG;


### print run commands for parallel ld comparisons
my $comp_count = 0;
open (my $out_runcom, '>', 'run_commands.txt') or die "could not open input file\n";
foreach my $comp1 (@group_list) {
	foreach my $comp2 (@group_list) {
		if ($comp2 eq $comp1) {next;}
		$comp_count++;
		print $out_runcom 'perl script_02.test_lg_pairwise_linkage.pl --lg_1 '."$comp1".' --lg_2 '."$comp2".' --output tempout/subout.'."$comp_count".'.txt'."\n";
	}
}
close $out_runcom;


