#!usr/bin/perl -w

use strict;
use warnings;

### save co-segregating marker information
my %marker_coseg;
my @marker_list;
my $mapped_marker;
open (my $read_coseg, '<', 'cosegregating_markers.txt') or die "could not open coseg file\n";
while (my $line = <$read_coseg>) {
	chomp $line;
	if (($line =~ /^Fvb/) || ($line =~ /^AX-/)) {
		my @line_sections = split /\s+/, $line;
		my $marker = $line_sections[0];
		push @marker_list, $marker;
	}
	elsif ($line =~ /^-----/) {
		my $save_coseg = join ";", @marker_list;
		foreach my $check_marker (@marker_list) {$marker_coseg{$check_marker} = $save_coseg;}
		@marker_list = ();
		undef @marker_list;
	}
	else {next;}
}
my $save_coseg = join ";", @marker_list;
foreach my $check_marker (@marker_list) {$marker_coseg{$check_marker} = $save_coseg;}
@marker_list = ();
undef @marker_list;
close $read_coseg;


### save list of mapped marker bins, their mapbin-id, and their linkage group assignment
open (my $read_map, '<', 'input_onemap_guardian.txt') or die "could not open input file\n";
open (my $output, '>', 'output_onemap_guardian_with_seg.txt') or die "could not open output file\n";
print $output "Marker\tStatus\tGroup\tcM\tHAP1_allele\tHAP2_allele\n";
while (my $line = <$read_map>) {
	chomp $line;
	if ($line =~ /^Marker/) {next;}
	my ($marker, $status, $LG, $cM, $h1, $h2) = split /\t/, $line;
	my @cosegs = split /;/, "$marker_coseg{$marker}";
	print $output "$line\n";
	foreach my $check_marker (@cosegs) {
		if ($check_marker eq $marker) {next;}
		my ($coseg_chr, $coseg_pos);
		if ($check_marker =~ /_/) {($coseg_chr, $coseg_pos) = split /_/, $check_marker;}
		else {
			$coseg_chr = 'unk';
			$coseg_pos = 'unk';
		}
		print $output "$check_marker\tcoseg\t$LG\t$cM\t-\t-\n";
	}
}
close $read_map;
close $output;

